gi-glib-2.0.30: GLib bindings

Copyright | Will Thompson and Iñaki García Etxebarria
License | LGPL-2.1
Maintainer | Iñaki García Etxebarria
Safe Haskell | None
Language | Haskell2010

GI.GLib.Structs.Tree

Contents

- Exported types
- Methods
  - destroy
  - foreach
  - foreachNode
  - height
  - insert
  - insertNode
  - lookup
  - lookupExtended
  - lookupNode
  - lowerBound
  - newFull
  - nnodes
  - nodeFirst
  - nodeLast
  - ref
  - remove
  - removeAll
  - replace
  - replaceNode
  - search
  - searchNode
  - steal
  - traverse
  - unref
  - upperBound

Description

The GTree struct is an opaque data structure representing a balanced binary tree. It should be accessed only by using the following functions.

Synopsis

- newtype Tree = Tree (ManagedPtr Tree)
- treeDestroy :: (HasCallStack, MonadIO m) => Tree -> m ()
- treeForeach :: (HasCallStack, MonadIO m) => Tree -> TraverseFunc -> m ()
- treeForeachNode :: (HasCallStack, MonadIO m) => Tree -> TraverseNodeFunc -> m ()
- treeHeight :: (HasCallStack, MonadIO m) => Tree -> m Int32
- treeInsert :: (HasCallStack, MonadIO m) => Tree -> Ptr () -> Ptr () -> m ()
- treeInsertNode :: (HasCallStack, MonadIO m) => Tree -> Ptr () -> Ptr () -> m (Maybe TreeNode)
- treeLookup :: (HasCallStack, MonadIO m) => Tree -> Ptr () -> m (Ptr ())
- treeLookupExtended :: (HasCallStack, MonadIO m) => Tree -> Ptr () -> m (Bool, Ptr (), Ptr ())
- treeLookupNode :: (HasCallStack, MonadIO m) => Tree -> Ptr () -> m (Maybe TreeNode)
- treeLowerBound :: (HasCallStack, MonadIO m) => Tree -> Ptr () -> m (Maybe TreeNode)
- treeNewFull :: (HasCallStack, MonadIO m) => CompareDataFunc -> DestroyNotify -> m Tree
- treeNnodes :: (HasCallStack, MonadIO m) => Tree -> m Int32
- treeNodeFirst :: (HasCallStack, MonadIO m) => Tree -> m (Maybe TreeNode)
- treeNodeLast :: (HasCallStack, MonadIO m) => Tree -> m (Maybe TreeNode)
- treeRef :: (HasCallStack, MonadIO m) => Tree -> m Tree
- treeRemove :: (HasCallStack, MonadIO m) => Tree -> Ptr () -> m Bool
- treeRemoveAll :: (HasCallStack, MonadIO m) => Tree -> m ()
- treeReplace :: (HasCallStack, MonadIO m) => Tree -> Ptr () -> Ptr () -> m ()
- treeReplaceNode :: (HasCallStack, MonadIO m) => Tree -> Ptr () -> Ptr () -> m (Maybe TreeNode)
- treeSearch :: (HasCallStack, MonadIO m) => Tree -> CompareFunc -> m (Ptr ())
- treeSearchNode :: (HasCallStack, MonadIO m) => Tree -> CompareFunc -> m (Maybe TreeNode)
- treeSteal :: (HasCallStack, MonadIO m) => Tree -> Ptr () -> m Bool
- treeTraverse :: (HasCallStack, MonadIO m) => Tree -> TraverseFunc -> TraverseType -> m ()
- treeUnref :: (HasCallStack, MonadIO m) => Tree -> m ()
- treeUpperBound :: (HasCallStack, MonadIO m) => Tree -> Ptr () -> m (Maybe TreeNode)

# Exported types

newtype Tree Source #

Memory-managed wrapper type.

Constructors

Tree (ManagedPtr Tree) |

#### Instances

Instances details

Eq Tree Source # |
Instance details Defined in GI.GLib.Structs.Tree Methods (==) :: Tree -> Tree -> Bool Source # (/=) :: Tree -> Tree -> Bool Source #
GBoxed Tree Source # |
Instance details Defined in GI.GLib.Structs.Tree
ManagedPtrNewtype Tree Source # |
Instance details Defined in GI.GLib.Structs.Tree Methods toManagedPtr :: Tree -> ManagedPtr Tree Source #
TypedObject Tree Source # |
Instance details Defined in GI.GLib.Structs.Tree Methods glibType :: IO GType Source #
HasParentTypes Tree Source # |
Instance details Defined in GI.GLib.Structs.Tree
IsGValue (Maybe Tree) Source # | Convert `Tree` to and from `GValue`. See `toGValue` and `fromGValue`.
Instance details Defined in GI.GLib.Structs.Tree Methods gvalueGType_ :: IO GType Source # gvalueSet_ :: Ptr GValue -> Maybe Tree -> IO () Source # gvalueGet_ :: Ptr GValue -> IO (Maybe Tree) Source #
type ParentTypes Tree Source # |
Instance details Defined in GI.GLib.Structs.Tree type ParentTypes Tree = '[] :: [Type]

# Methods

### Click to display all available methods, including inherited ones

Expand

#### Methods

destroy, foreach, foreachNode, height, insert, insertNode, lookup, lookupExtended, lookupNode, lowerBound, nnodes, nodeFirst, nodeLast, ref, remove, removeAll, replace, replaceNode, search, searchNode, steal, traverse, unref, upperBound.

#### Getters

None.

#### Setters

None.

## destroy

treeDestroy Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> Tree | `tree`: a `Tree`
-> m () |

Removes all keys and values from the `Tree` and decreases its reference count by one. If keys and/or values are dynamically allocated, you should either free them first or create the `Tree` using `treeNewFull`. In the latter case the destroy functions you supplied will be called on all keys and values before destroying the `Tree`.

## foreach

treeForeach Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> Tree | `tree`: a `Tree`
-> TraverseFunc | `func`: the function to call for each node visited. If this function returns `True`, the traversal is stopped.
-> m () |

Calls the given function for each of the key/value pairs in the `Tree`. The function is passed the key and value of each pair, and the given `data` parameter. The tree is traversed in sorted order.

The tree may not be modified while iterating over it (you can't add/remove items). To remove all items matching a predicate, you need to add each item to a list in your `TraverseFunc` as you walk over the tree, then walk the list and remove each item.

## foreachNode

treeForeachNode Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> Tree | `tree`: a `Tree`
-> TraverseNodeFunc | `func`: the function to call for each node visited. If this function returns `True`, the traversal is stopped.
-> m () |

Calls the given function for each of the nodes in the `Tree`. The function is passed the pointer to the particular node, and the given `data` parameter. The tree traversal happens in-order.

The tree may not be modified while iterating over it (you can't add/remove items). To remove all items matching a predicate, you need to add each item to a list in your `TraverseFunc` as you walk over the tree, then walk the list and remove each item.

Since: 2.68

## height

treeHeight Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> Tree | `tree`: a `Tree`
-> m Int32 | Returns: the height of `tree`

Gets the height of a `Tree`.

If the `Tree` contains no nodes, the height is 0. If the `Tree` contains only one root node the height is 1. If the root node has children the height is 2, etc.

## insert

treeInsert Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> Tree | `tree`: a `Tree`
-> Ptr () | `key`: the key to insert
-> Ptr () | `value`: the value corresponding to the key
-> m () |

Inserts a key/value pair into a `Tree`.

Inserts a new key and value into a `Tree` as `treeInsertNode` does, only this function does not return the inserted or set node.

## insertNode

treeInsertNode Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> Tree | `tree`: a `Tree`
-> Ptr () | `key`: the key to insert
-> Ptr () | `value`: the value corresponding to the key
-> m (Maybe TreeNode) | Returns: the inserted (or set) node or `Nothing` if insertion would overflow the tree node counter.

Inserts a key/value pair into a `Tree`.

If the given key already exists in the `Tree` its corresponding value is set to the new value. If you supplied a `valueDestroyFunc` when creating the `Tree`, the old value is freed using that function. If you supplied a `keyDestroyFunc` when creating the `Tree`, the passed key is freed using that function.

The tree is automatically 'balanced' as new key/value pairs are added, so that the distance from the root to every leaf is as small as possible. The cost of maintaining a balanced tree while inserting new key/value result in a O(n log(n)) operation where most of the other operations are O(log(n)).

Since: 2.68

## lookup

treeLookup Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> Tree | `tree`: a `Tree`
-> Ptr () | `key`: the key to look up
-> m (Ptr ()) | Returns: the value corresponding to the key, or `Nothing` if the key was not found

Gets the value corresponding to the given key. Since a `Tree` is automatically balanced as key/value pairs are added, key lookup is O(log n) (where n is the number of key/value pairs in the tree).

## lookupExtended

treeLookupExtended Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> Tree | `tree`: a `Tree`
-> Ptr () | `lookupKey`: the key to look up
-> m (Bool, Ptr (), Ptr ()) | Returns: `True` if the key was found in the `Tree`

Looks up a key in the `Tree`, returning the original key and the associated value. This is useful if you need to free the memory allocated for the original key, for example before calling `treeRemove`.

## lookupNode

treeLookupNode Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> Tree | `tree`: a `Tree`
-> Ptr () | `key`: the key to look up
-> m (Maybe TreeNode) | Returns: the tree node corresponding to the key, or `Nothing` if the key was not found

Gets the tree node corresponding to the given key. Since a `Tree` is automatically balanced as key/value pairs are added, key lookup is O(log n) (where n is the number of key/value pairs in the tree).

Since: 2.68

## lowerBound

treeLowerBound Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> Tree | `tree`: a `Tree`
-> Ptr () | `key`: the key to calculate the lower bound for
-> m (Maybe TreeNode) | Returns: the tree node corresponding to the lower bound, or `Nothing` if the tree is empty or has only keys strictly lower than the searched key.

Gets the lower bound node corresponding to the given key, or `Nothing` if the tree is empty or all the nodes in the tree have keys that are strictly lower than the searched key.

The lower bound is the first node that has its key greater than or equal to the searched key.

Since: 2.68

## newFull

treeNewFull Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> CompareDataFunc | `keyCompareFunc`: `qsort()`-style comparison function
-> DestroyNotify | `keyDestroyFunc`: a function to free the memory allocated for the key used when removing the entry from the `Tree` or `Nothing` if you don't want to supply such a function
-> m Tree | Returns: a newly allocated `Tree`

Creates a new `Tree` like `g_tree_new()` and allows to specify functions to free the memory allocated for the key and value that get called when removing the entry from the `Tree`.

## nnodes

treeNnodes Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> Tree | `tree`: a `Tree`
-> m Int32 | Returns: the number of nodes in `tree` The node counter value type is really a `guint`, but it is returned as a `gint` due to backward compatibility issues (can be cast back to `guint` to support its full range of values).

Gets the number of nodes in a `Tree`.

## nodeFirst

treeNodeFirst Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> Tree | `tree`: a `Tree`
-> m (Maybe TreeNode) | Returns: the first node in the tree

Returns the first in-order node of the tree, or `Nothing` for an empty tree.

Since: 2.68

## nodeLast

treeNodeLast Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> Tree | `tree`: a `Tree`
-> m (Maybe TreeNode) | Returns: the last node in the tree

Returns the last in-order node of the tree, or `Nothing` for an empty tree.

Since: 2.68

## ref

treeRef Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> Tree | `tree`: a `Tree`
-> m Tree | Returns: the passed in `Tree`

Increments the reference count of `tree` by one.

It is safe to call this function from any thread.

Since: 2.22

## remove

treeRemove Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> Tree | `tree`: a `Tree`
-> Ptr () | `key`: the key to remove
-> m Bool | Returns: `True` if the key was found (prior to 2.8, this function returned nothing)

Removes a key/value pair from a `Tree`.

If the `Tree` was created using `treeNewFull`, the key and value are freed using the supplied destroy functions, otherwise you have to make sure that any dynamically allocated values are freed yourself. If the key does not exist in the `Tree`, the function does nothing.

The cost of maintaining a balanced tree while removing a key/value result in a O(n log(n)) operation where most of the other operations are O(log(n)).

## removeAll

treeRemoveAll Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> Tree | `tree`: a `Tree`
-> m () |

Removes all nodes from a `Tree` and destroys their keys and values, then resets the `Tree`’s root to `Nothing`.

Since: 2.70

## replace

treeReplace Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> Tree | `tree`: a `Tree`
-> Ptr () | `key`: the key to insert
-> Ptr () | `value`: the value corresponding to the key
-> m () |

Inserts a new key and value into a `Tree` as `treeReplaceNode` does, only this function does not return the inserted or set node.

## replaceNode

treeReplaceNode Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> Tree | `tree`: a `Tree`
-> Ptr () | `key`: the key to insert
-> Ptr () | `value`: the value corresponding to the key
-> m (Maybe TreeNode) | Returns: the inserted (or set) node or `Nothing` if insertion would overflow the tree node counter.

Inserts a new key and value into a `Tree` similar to `treeInsertNode`. The difference is that if the key already exists in the `Tree`, it gets replaced by the new key. If you supplied a `valueDestroyFunc` when creating the `Tree`, the old value is freed using that function. If you supplied a `keyDestroyFunc` when creating the `Tree`, the old key is freed using that function.

The tree is automatically 'balanced' as new key/value pairs are added, so that the distance from the root to every leaf is as small as possible.

Since: 2.68

## search

treeSearch Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> Tree | `tree`: a `Tree`
-> CompareFunc | `searchFunc`: a function used to search the `Tree`
-> m (Ptr ()) | Returns: the value corresponding to the found key, or `Nothing` if the key was not found

Searches a `Tree` using `searchFunc`.

The `searchFunc` is called with a pointer to the key of a key/value pair in the tree, and the passed in `userData`. If `searchFunc` returns 0 for a key/value pair, then the corresponding value is returned as the result of `treeSearch`. If `searchFunc` returns -1, searching will proceed among the key/value pairs that have a smaller key; if `searchFunc` returns 1, searching will proceed among the key/value pairs that have a larger key.

## searchNode

treeSearchNode Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> Tree | `tree`: a `Tree`
-> CompareFunc | `searchFunc`: a function used to search the `Tree`
-> m (Maybe TreeNode) | Returns: the node corresponding to the found key, or `Nothing` if the key was not found

Searches a `Tree` using `searchFunc`.

The `searchFunc` is called with a pointer to the key of a key/value pair in the tree, and the passed in `userData`. If `searchFunc` returns 0 for a key/value pair, then the corresponding node is returned as the result of `treeSearch`. If `searchFunc` returns -1, searching will proceed among the key/value pairs that have a smaller key; if `searchFunc` returns 1, searching will proceed among the key/value pairs that have a larger key.

Since: 2.68

## steal

treeSteal Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> Tree | `tree`: a `Tree`
-> Ptr () | `key`: the key to remove
-> m Bool | Returns: `True` if the key was found (prior to 2.8, this function returned nothing)

Removes a key and its associated value from a `Tree` without calling the key and value destroy functions.

If the key does not exist in the `Tree`, the function does nothing.

## traverse

treeTraverse Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> Tree | `tree`: a `Tree`
-> TraverseFunc | `traverseFunc`: the function to call for each node visited. If this function returns `True`, the traversal is stopped.
-> TraverseType | `traverseType`: the order in which nodes are visited, one of `TraverseTypeInOrder`, `TraverseTypePreOrder` and `TraverseTypePostOrder`
-> m () |

Deprecated: (Since version 2.2)The order of a balanced tree is somewhat arbitrary.If you just want to visit all nodes in sorted order, use`treeForeach` instead. If you really need to visit nodes ina different order, consider using an n-ary tree.

Calls the given function for each node in the `Tree`.

## unref

treeUnref Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> Tree | `tree`: a `Tree`
-> m () |

Decrements the reference count of `tree` by one. If the reference count drops to 0, all keys and values will be destroyed (if destroy functions were specified) and all memory allocated by `tree` will be released.

It is safe to call this function from any thread.

Since: 2.22

## upperBound

treeUpperBound Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> Tree | `tree`: a `Tree`
-> Ptr () | `key`: the key to calculate the upper bound for
-> m (Maybe TreeNode) | Returns: the tree node corresponding to the upper bound, or `Nothing` if the tree is empty or has only keys lower than or equal to the searched key.

Gets the upper bound node corresponding to the given key, or `Nothing` if the tree is empty or all the nodes in the tree have keys that are lower than or equal to the searched key.

The upper bound is the first node that has its key strictly greater than the searched key.

Since: 2.68